FLTK 1.3.3: Fl_RGB_Image Class Reference

FLTK 1.3.3

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Public Attributes | Friends | List of all members
Fl_RGB_Image Class Reference

The Fl_RGB_Image class supports caching and drawing of full-color images with 1 to 4 channels of color information. More...

`#include <Fl_Image.H>`

Inheritance diagram for Fl_RGB_Image:

## Public Member Functions
virtual void | color_average (Fl_Color c, float i)
| The color_average() method averages the colors in the image with the FLTK color value c. More...
virtual Fl_Image * | copy (int W, int H)
| The copy() method creates a copy of the specified image. More...
Fl_Image * | copy ()
virtual void | desaturate ()
| The desaturate() method converts an image to grayscale. More...
virtual void | draw (int X, int Y, int W, int H, int cx=0, int cy=0)
| Draws the image with a bounding box. More...
void | draw (int X, int Y)
| Fl_RGB_Image (const uchar *bits, int W, int H, int D=3, int LD=0)
| The constructor creates a new image from the specified data. More...
| Fl_RGB_Image (const Fl_Pixmap *pxm, Fl_Color bg=FL_GRAY)
| The constructor creates a new RGBA image from the specified Fl_Pixmap. More...
virtual void | label (Fl_Widget *w)
| The label() methods are an obsolete way to set the image attribute of a widget or menu item. More...
virtual void | label (Fl_Menu_Item *m)
| The label() methods are an obsolete way to set the image attribute of a widget or menu item. More...
virtual void | uncache ()
| If the image has been cached for display, delete the cache data. More...
virtual | ~Fl_RGB_Image ()
| The destructor frees all memory and server resources that are used by the image. More...
Public Member Functions inherited from Fl_Image
Fl_Image * | copy ()
| The copy() method creates a copy of the specified image. More...
int | count () const
| The count() method returns the number of data values associated with the image. More...
int | d () const
| Returns the current image depth. More...
const char *const * | data () const
| Returns a pointer to the current image data array. More...
void | draw (int X, int Y)
| Draws the image. More...
| Fl_Image (int W, int H, int D)
| The constructor creates an empty image with the specified width, height, and depth. More...
int | h () const
| Returns the current image height in pixels.
void | inactive ()
| The inactive() method calls color_average(FL_BACKGROUND_COLOR, 0.33f) to produce an image that appears grayed out. More...
int | ld () const
| Returns the current line data size in bytes. More...
int | w () const
| Returns the current image width in pixels.
virtual | ~Fl_Image ()
| The destructor is a virtual method that frees all memory used by the image.

## Static Public Member Functions
static void | max_size (size_t size)
| Sets the maximum allowed image size in bytes when creating an Fl_RGB_Image object. More...
static size_t | max_size ()
| Returns the maximum allowed image size in bytes when creating an Fl_RGB_Image object. More...
Static Public Member Functions inherited from Fl_Image
static void | RGB_scaling (Fl_RGB_Scaling)
| Sets the RGB image scaling method used for copy(int, int). More...
static Fl_RGB_Scaling | RGB_scaling ()
| Returns the currently used RGB image scaling method. More...

## Public Attributes
int | alloc_array
const uchar * | array

## Friends
class | Fl_GDI_Graphics_Driver
class | Fl_Quartz_Graphics_Driver
class | Fl_Xlib_Graphics_Driver

## Additional Inherited Members
Protected Member Functions inherited from Fl_Image
void | d (int D)
| Sets the current image depth.
void | data (const char *const *p, int c)
| Sets the current array pointer and count of pointers in the array.
void | draw_empty (int X, int Y)
| The protected method draw_empty() draws a box with an X in it. More...
void | h (int H)
| Sets the current image height in pixels.
void | ld (int LD)
| Sets the current line data size in bytes.
void | w (int W)
| Sets the current image width in pixels.
Static Protected Member Functions inherited from Fl_Image
static void | labeltype (const Fl_Label *lo, int lx, int ly, int lw, int lh, Fl_Align la)
static void | measure (const Fl_Label *lo, int &lw, int &lh)

## Detailed Description

The Fl_RGB_Image class supports caching and drawing of full-color images with 1 to 4 channels of color information.

Images with an even number of channels are assumed to contain alpha information, which is used to blend the image with the contents of the screen.

Fl_RGB_Image is defined in <FL/Fl_Image.H>, however for compatibility reasons <FL/Fl_RGB_Image.H> should be included.

## Constructor & Destructor Documentation

Fl_RGB_Image::Fl_RGB_Image | ( | const uchar * | bits,
|  | int | W,
|  | int | H,
|  | int | D = `3`,
|  | int | LD = `0`
| ) |  |
| inline

The constructor creates a new image from the specified data.

Parameters

  [in] | bits | The image data array.
  [in] | W | The width of the image in pixels
  [in] | H | The height of the image in pixels
  [in] | D | The image depth, or 'number of channels'. Default=3 If D=1, each uchar in bits[] is a grayscale pixel value. If D=2, each uchar pair in bits[] is a grayscale + alpha pixel value. If D=3, each uchar triplet in bits[] is an R/G/B pixel value If D=4, each uchar quad in bits[] is an R/G/B/A pixel value.
  [in] | LD | Line data size (default=0). Line data is extra data that is included after each line of color image data and is normally not present.

See also
  Fl_Image::data(), Fl_Image::w(), Fl_Image::h(), Fl_Image::d(), Fl_Image::ld()

Fl_RGB_Image::Fl_RGB_Image | ( | const Fl_Pixmap * | pxm,
|  | Fl_Color | bg = `FL_GRAY`
| ) |  |

The constructor creates a new RGBA image from the specified Fl_Pixmap.

The RGBA image is built fully opaque except for the transparent area of the pixmap that is assigned the

bg color with full transparency

Fl_RGB_Image::~Fl_RGB_Image | ( |  | ) |
| virtual

The destructor frees all memory and server resources that are used by the image.

## Member Function Documentation

void Fl_RGB_Image::color_average | ( | Fl_Color | c,
|  | float | i
| ) |  |
| virtual

The color_average() method averages the colors in the image with the FLTK color value c.

The i argument specifies the amount of the original image to combine with the color, so a value of 1.0 results in no color blend, and a value of 0.0 results in a constant image of the specified color. The original image data is not altered by this method.

Reimplemented from Fl_Image.

Fl_Image * Fl_RGB_Image::copy | ( | int | W,
|  | int | H
| ) |  |
| virtual

The copy() method creates a copy of the specified image.

If the width and height are provided, the image is resized to the specified size. The image should be deleted (or in the case of Fl_Shared_Image, released) when you are done with it.

Reimplemented from Fl_Image.

void Fl_RGB_Image::desaturate | ( |  | ) |
| virtual

The desaturate() method converts an image to grayscale.

If the image contains an alpha channel (depth = 4), the alpha channel is preserved. This method does not alter the original image data.

Reimplemented from Fl_Image.

void Fl_RGB_Image::draw | ( | int | X,
|  | int | Y,
|  | int | W,
|  | int | H,
|  | int | cx = `0`,
|  | int | cy = `0`
| ) |  |
| virtual

Draws the image with a bounding box.

This form specifies a bounding box for the image, with the origin (upper-lefthand corner) of the image offset by the cx and cy arguments.

Reimplemented from Fl_Image.

void Fl_RGB_Image::label | ( | Fl_Widget * | widget | ) |
| virtual

The label() methods are an obsolete way to set the image attribute of a widget or menu item.

Use the image() or deimage() methods of the Fl_Widget and Fl_Menu_Item classes instead.

Reimplemented from Fl_Image.

void Fl_RGB_Image::label | ( | Fl_Menu_Item * | m | ) |
| virtual

The label() methods are an obsolete way to set the image attribute of a widget or menu item.

Use the image() or deimage() methods of the Fl_Widget and Fl_Menu_Item classes instead.

Reimplemented from Fl_Image.

static void Fl_RGB_Image::max_size | ( | size_t | size | ) |
| inlinestatic

Sets the maximum allowed image size in bytes when creating an Fl_RGB_Image object.

The image size in bytes of an Fl_RGB_Image object is the value of the product w() * h() * d(). If this product exceeds size, the created object of a derived class of Fl_RGB_Image won't be loaded with the image data. This does not apply to direct RGB image creation with Fl_RGB_Image::Fl_RGB_Image(const uchar *bits, int W, int H, int D, int LD). The default max_size() value is essentially infinite.

static size_t Fl_RGB_Image::max_size | ( |  | ) |
| inlinestatic

Returns the maximum allowed image size in bytes when creating an Fl_RGB_Image object.

See also
  void Fl_RGB_Image::max_size(size_t)

void Fl_RGB_Image::uncache | ( |  | ) |
| virtual

If the image has been cached for display, delete the cache data.

This allows you to change the data used for the image and then redraw it without recreating an image object.

Reimplemented from Fl_Image.

The documentation for this class was generated from the following files:

- Fl_Image.H
- Fl_Image.cxx

- © 1998-2014 by Bill Spitzak and others.